﻿#pragma once

#include "stdafx.h"
#include "UpdateManager.h"
#include "afxcmn.h"
#include "SkinDialog.h"
#include "afxwin.h"
#include "AttachDownloadList.h"

// CAtatchDownload 대화 상자입니다.

#define DEF_FILE_DOWNLOAD_BG_COLOR					Color(255, 255, 255, 255)
#define DEF_FILE_DOWNLOAD_LINE_COLOR				Color(255, 220, 220, 220)

#define DEF_FILE_DOWNLOAD_FONT_NAME					(L"나눔고딕")
#define DEF_FILE_DOWNLOAD_FONT_HEIGHT				(10)
#define DEF_FILE_DOWNLOAD_FONT_COLOR				Color(255, 34, 34, 34)
#define DEF_FILE_DOWNLOAD_FONT_STYLE				(FontStyleRegular)

#define DEF_FILE_DOWNLOAD_LIST_FONT_NAME			(L"나눔고딕")
#define DEF_FILE_DOWNLOAD_LIST_FONT_HEIGHT			(9)
#define DEF_FILE_DOWNLOAD_LIST_FONT_COLOR			Color(255, 102, 102, 102)
#define DEF_FILE_DOWNLOAD_LIST_FONT_STYLE			(FontStyleRegular)

#define DEF_FILE_DOWNLOAD_SENDSPEED_LEFT_POS_X		(20)
#define DEF_FILE_DOWNLOAD_SENDSPEED_TOP_POS_Y		(20)
#define DEF_FILE_DOWNLOAD_TITLEVALUE_GAP_POS_X		(12)
#define DEF_FILE_DOWNLOAD_REMAINTIME_LEFT_POS_X		(178)
#define DEF_FILE_DOWNLOAD_TOTALSIZE_TITLE_POS_X		(150)
#define DEF_FILE_DOWNLOAD_TOTALSIZE_RIGHT_POS_X		(20)
#define DEF_FILE_DOWNLOAD_REMAINTIME_WIDTH			(155)
#define DEF_FILE_DOWNLOAD_PROGRESS_TOP_POS_Y		(50)
#define DEF_FILE_DOWNLOAD_PROGRESS_GAP_POS_X		(12)
#define DEF_FILE_DOWNLOAD_PROGRESS_RIGHT_POS_X		(20)
#define DEF_FILE_DOWNLOAD_LIST_LEFT_POS_X			(20)
#define DEF_FILE_DOWNLOAD_LIST_TOP_POS_Y			(85)
#define DEF_FILE_DOWNLOAD_LIST_LINE_GAP_Y			(20)
#define DEF_FILE_DOWNLOAD_BOTTOMLINE_POS_Y			(48)
#define DEF_FILE_DOWNLOAD_BUTTON_WIDTH				(80)
#define DEF_FILE_DOWNLOAD_BUTTON_HEIGHT				(28)

#define DEF_ATTACH_LIST_ITEM_HEIGHT					(22)
#define DEF_MIN_ATTACH_SIZE_WIDTH					(480)
#define DEF_MIN_ATTACH_SIZE_HEIGHT					(330)

#define DEF_FILE_DOWNLOAD_LIST_COLNAME_WIDTH_PCT	(50)
#define DEF_FILE_DOWNLOAD_LIST_COLNAME_SIZE_PCT		(25)
#define DEF_FILE_DOWNLOAD_LIST_COLNAME_STATUS_PCT	(25)

class CAtatchDownload : public CDialog
{
	DECLARE_DYNCREATE(CAtatchDownload)

public:
	CAtatchDownload(CWnd* pParent = NULL);   // 표준 생성자입니다.
	virtual ~CAtatchDownload();
// 재정의입니다.	
	static UINT _DownloadThread(LPVOID pParam);

// 대화 상자 데이터입니다.
	enum { IDD = IDD_DIALOG_DOWNLOAD};//, IDH = IDR_HTML_ATATCHDOWNLOAD };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV 지원입니다.

	CUpdateManager		m_updateManager;
	CWinThread*			m_pThread;

	CButton				m_btnClose;
	CAttachDownloadList	m_listFiles;
	
	CString				m_strDownPath;
	CString				m_strCurDownloadFileName;
	int					m_nDownCnt;

	ULONGLONG			m_dwTotalSize;
	ULONGLONG			m_dwCurDownloadSize;
	
	COleDateTime		m_dtDownloadStart;

	Image*				m_pImgBG;
	Image*				m_pImgProgressBG;
	Image*				m_pImgProgressFG;

	Color				m_crBG;
	Color				m_crOutline;


	WCHAR				m_wszFontName[64];
	REAL				m_nFontHeight;
	FontStyle			m_fontStyle;
	Color				m_crText;


	CString				m_strSendSpeedTitle;
	CString				m_strSendSpeedValue;
	CString				m_strRemainTimeTitle;
	CString				m_strRemainTimeValue;
	CString				m_strTotalSizeTitle;
	CString				m_strTotalSizeValue;
	CString				m_strProgressTitle;

	CRect				m_rtWnd;
	CRect				m_rtSendSpeedTitle;
	CSize				m_szSendSpeedTitle;
	CRect				m_rtSendSpeedValue;
	CRect				m_rtRemainTimeTitle;
	CSize				m_szRemainTimeTitle;
	CRect				m_rtRemainTimeValue;
	CRect				m_rtTotalSizeTitle;
	CSize				m_szTotalSizeTitle;
	CRect				m_rtTotalSizeValue;
	CRect				m_rtProgressTitle;
	CSize				m_szProgressTitle;
	CRect				m_rtProgressValue;
	CRect				m_rtFileDownloadList;
	CRect				m_rtBtnClose;

public:
	void				SetSendSpeedTitle(CString strTitle)					{ m_strSendSpeedTitle = strTitle; }
	void				SetRemainTimeTitle(CString strTitle)				{ m_strRemainTimeTitle = strTitle; }
	void				SetTotalSizeTitle(CString strTitle)					{ m_strTotalSizeTitle = strTitle; }
	void				SetProgressTitle(CString strTitle)					{ m_strProgressTitle = strTitle; }
	void				SetFontConfig(WCHAR* wszFontName, REAL nFontHeight, FontStyle style, Color crText);
	void				SetImgBGPath(CString strFileName);
	void				SetImgProgressPath(CString strFileNameFG, CString strFileNameBG);

	void				UpdateSpeedTime();
	void				ResizeCtrl(void);
	void				AddDownloadFile(CString strURL, CString strDownPath, CString strFileName, CString strSize);
	bool				DoDownload(void);
	void				SetSkin();	
	void				SetFileRename(LPCTSTR strSrcName, LPCTSTR strDestName);
	void				SetOpenFolderAfterDownload(BOOL bOpen);
	BOOL				IsOpenFolderAfterDownload()	{ return m_bOpenFolderAfterDownload; }

	LRESULT				DownloadBegin(WPARAM wParam, LPARAM lParam);
	LRESULT				DownloadBytes(WPARAM wParam, LPARAM lParam);
	LRESULT				DownloadEnd(WPARAM wParam, LPARAM lParam);

protected:	
	virtual BOOL OnInitDialog();
	virtual BOOL PreTranslateMessage(MSG* pMsg);	
	void DrawDownloadTextInfo( Graphics &graph, CRect rtPS );
	void DrawProgressBar( Graphics &graph, CRect rtPS, ImageAttributes &ImgAttr );

protected:
	DECLARE_MESSAGE_MAP()

public:	
	afx_msg void OnDestroy();
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	afx_msg void OnPaint();	
	afx_msg void OnSize(UINT nType, int cx, int cy);

	DECLARE_DHTML_EVENT_MAP()
	afx_msg void OnBnClickedOk();
private:
	//int m_nHitTest;
	//int m_nBorderHeight;
	//int m_nBorderWidth;
	BOOL m_bOpenFolderAfterDownload;

public:
	afx_msg void OnGetMinMaxInfo(MINMAXINFO* lpMMI);
};

